apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ roundcube_name }}
  name: {{ roundcube_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ roundcube_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ roundcube_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ roundcube_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ roundcube_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ roundcube_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ roundcube_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: APACHE_DOMAIN
          value: {{ roundcube_fqdn }}
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DES_KEY
          valueFrom:
            secretKeyRef:
              key: des-key
              name: {{ roundcube_name }}
        - name: IMAP_HOST
{% if imaps_address | default(False) %}
          value: {{ imaps_address | urlsplit('hostname') }}
        - name: IMAP_PORT
          value: "{{ imaps_address | urlsplit('port') }}"
        - name: IMAP_PROTO
          value: {{ imaps_address | urlsplit('scheme') }}
{% else %}
          value: {{ imap_address | urlsplit('hostname') }}
        - name: IMAP_PORT
          value: "{{ imap_address | urlsplit('port') }}"
        - name: IMAP_PROTO
          value: {{ imap_address | urlsplit('scheme') }}
{% endif %}
        - name: IMAP_VENDOR
          value: cyrus
        - name: MAIL_DOMAIN
          value: {{ root_domain }}
{% if roundcube_db_type == 'percona' %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ rndcbpc_name }}
        - name: MYSQL_HOST
          value: {{ rndcbpc_name }}-client
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ rndcbpc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ rndcbpc_name }}
{% elif roundcube_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ rndcbms_name }}
        - name: MYSQL_HOST
          value: {{ rndcbms_name }}
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ rndcbms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ rndcbms_name }}
{% else %}
        - name: MYSQL_PASSWORD
          value: ""
{% endif %}
        - name: PHP_MAX_EXECUTION_TIME
          value: "{{ roundcube_php_max_execution_time }}"
        - name: PHP_MEMORY_LIMIT
          value: {{ roundcube_php_memory_limit }}
{% if roundcube_db_type == 'postgres' %}
        - name: POSTGRES_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ rndcbpg_name }}
        - name: POSTGRES_HOST
          value: {{ rndcbpg_name }}
        - name: POSTGRES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ rndcbpg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ rndcbpg_name }}
{% else %}
        - name: POSTGRES_PASSWORD
          value: ""
{% endif %}
        - name: PUBLIC_PROTO
          value: https
        - name: ROUNDCUBE_SITE_NAME
          value: {{ roundcube_application_title }}
        - name: ROUNDCUBE_SKIN
          value: {{ roundcube_skin }}
        - name: SMTP_HELO
          valueFrom:
            fieldRef:
              fieldPath: spec.nodeName
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: ZPUSH_HOST
{% if zpush_api_address | default(False) %}
          value: {{ zpush_api_address | urlsplit('hostname') }}
        - name: ZPUSH_PORT
          value: "{{ zpush_api_address | urlsplit('port') }}"
{% else %}
          value: ""
        - name: ZPUSH_PORT
          value: ""
{% endif %}
{% if do_triggers == False or (opsimages | json_query("[?name=='roundcube'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='roundcube'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 28
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /favicon.ico
            port: 8080
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: roundcube
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /favicon.ico
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ roundcube_cpu_limit }}"
            memory: "{{ roundcube_memory_limit }}"
          requests:
            cpu: "{{ roundcube_cpu_request }}"
            memory: "{{ roundcube_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 28
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: apachesites
          subPath: apachesites
        - mountPath: /usr/local/share/ca-certificates
          name: apachesites
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: apachesites
          subPath: empty
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ roundcube_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: apachesites
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if cyrus_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='roundcube'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - roundcube
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='roundcube'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
